"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const slash_1 = __importDefault(require("slash"));
const defaultPublicToFile = (publicPath, root) => path_1.default.join(root, publicPath.slice(1));
const defaultFileToPublic = (filePath, root) => `/${slash_1.default(path_1.default.relative(root, filePath))}`;
function createResolver(root, resolvers) {
    return {
        publicToFile: (publicPath) => {
            for (const r of resolvers) {
                const filepath = r.publicToFile(publicPath, root);
                if (filepath)
                    return filepath;
            }
            return defaultPublicToFile(publicPath, root);
        },
        fileToPublic: (filePath) => {
            for (const r of resolvers) {
                const filepath = r.fileToPublic(filePath, root);
                if (filepath)
                    return filepath;
            }
            return defaultFileToPublic(filePath, root);
        }
    };
}
exports.createResolver = createResolver;
