/// <reference types="node" />
import { Server } from 'http';
import Koa from 'koa';
import { FSWatcher } from 'chokidar';
import { Resolver, InternalResolver } from './resolver';
export { Resolver };
export declare type Plugin = (ctx: PluginContext) => void;
export declare type ViteWatcher = FSWatcher & {
    handleVueReload: (file: string, timestamp: number, content?: string) => void;
    handleJSReload: (file: string, timestamp: number) => void;
};
export interface PluginContext {
    root: string;
    app: Koa;
    server: Server;
    watcher: ViteWatcher;
    resolver: InternalResolver;
}
export interface ServerConfig {
    root?: string;
    plugins?: Plugin[];
    resolvers?: Resolver[];
}
export declare function createServer(config?: ServerConfig): Server;
